//+------------------------------------------------------------------+
//|       Dserg_Auto_v1.0.mq4                                        |
//|         EURUSD_M15 / 2009                      |
//+------------------------------------------------------------------+
#property copyright "Dserg"
#property link      "http://forum.alpari.ru/member56010.html"
#include <stdlib.mqh>

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
extern double Lots = 0.01;

extern double StopLoss = 100000;
extern double TakeProfit = 100000;

extern int periodMA = 55;
extern int Step = 200;
extern double coeff = 0.2;
extern double in_coeff = 0.05;
extern int maxLotsN = 10;

static double trend = 1.0;
static datetime d_low = D'2010.01.01';
static datetime d_high = D'2010.01.01';


static datetime LT=0;
extern int MagicNumber=7461240;        
string ExpertName;  
int TradesInThisSymbol;
static int dir1 = 0;

static double curF,LastB,LastdB;
static string strB;
static double Bal[100];
extern int F=100;
extern int Nfast = 10;
extern int Nslow = 50;
extern bool useF = true;

static double curF1,LastB1,LastdB1;
static double Bal1[100];
extern int F1=100;
extern int Nfast1 = 10;
extern int Nslow1 = 50;
extern bool useF1 = true;

static int dir;
static double prevF;

static double cur_high, cur_low;



int init()
{
    
    ExpertName="ExpertName" + MagicNumber + " : " + Symbol();

     curF=F;
    LastB=0;
    LastdB=0; 
    ArrayInitialize(Bal,0);
    curF1=F1;
    LastB1=0;
    LastdB1=0; 
    ArrayInitialize(Bal1,0);
    dir=1;
    prevF=F;
  
    cur_high = iMA(NULL,0,periodMA,0,MODE_EMA,PRICE_CLOSE,1);
    cur_low = iMA(NULL,0,periodMA,0,MODE_EMA,PRICE_CLOSE,1);

   return(0);
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
{
   return(0);
}

//+------------------------------------------------------------------+
//| OpenBuyOrder                                                    |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenBuyOrder()
{
   int err,ticket;
   double myStopLoss = 0, myTakeProfit = 0;
   myStopLoss = 0;
   myTakeProfit = 0;
   
   RefreshRates();
   
   //    
   myStopLoss = Ask - StopLoss*Point;
   myTakeProfit = Ask + TakeProfit*Point;

   //   
   double Lots1;
   if (useF1) {
      Lots1 = NormalizeDouble(Lots*MathMin(curF,curF1),2);
   } else {
      Lots1 = NormalizeDouble(Lots*curF,2);
   }
    
   RefreshRates();
   
   ticket=OrderSend(Symbol(),OP_BUY,Lots1,Ask,30,myStopLoss,myTakeProfit,"forward",MagicNumber,0,Green); 
   if(ticket<=0)
   {
      err = GetLastError();
      Print("Error opening BUY order [" + ExpertName + "]: (" + err + ") " + ErrorDescription(err)); 
   }
}


//+------------------------------------------------------------------+
//| OpenSellOrder                                                    |
//| If Stop Loss or TakeProfit are used the values are calculated    |
//| for each trade                                                   |
//+------------------------------------------------------------------+
void OpenSellOrder()
{
   int err,ticket;
   double myStopLoss = 0, myTakeProfit = 0;
   myStopLoss = 0;
   myTakeProfit = 0;
   
   RefreshRates();
   
   //    
   myStopLoss = Bid + StopLoss*Point;
   myTakeProfit = Bid - TakeProfit*Point;
    
    //   
   double Lots1;
   if (useF1) {
      Lots1 = NormalizeDouble(Lots*MathMin(curF,curF1),2);
   } else {
      Lots1 = NormalizeDouble(Lots*curF,2);
   }
  
   RefreshRates();
   
   ticket=OrderSend(Symbol(),OP_SELL,Lots1,Bid,30,myStopLoss,myTakeProfit,"forward",MagicNumber,0,Red); 
   if(ticket<=0)
   {
      err = GetLastError();
      Print("Error opening SELL order [" + ExpertName + "]: (" + err + ") " + ErrorDescription(err)); 
   }
}


//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{
//----
   if (Time[0]==LT) return(0);
   LT = Time[0];

   if (useF) {
      curF=getF();
   } else {
      curF=F;
   }
   if (useF1) {
      curF1=getF1();
   } else {
      curF1=F1;
   }
   if (curF==1&&prevF==F) {
      dir=-dir;
   }
   prevF=curF;
   
   int Nb = openPositionsDet(OP_BUY , "forward");
   int Ns = openPositionsDet(OP_SELL , "forward");

   double ma0=iMA(NULL,0,periodMA,0,MODE_EMA,PRICE_CLOSE,1);
   ma0 /= Step*Point;
   ma0 = NormalizeDouble(ma0,0);
   ma0 *= Step*Point;
   
   int cur_bars, bars_high, bars_low;
   
   if (trend>0) {
      cur_high = MathMax(cur_high,ma0);
      if (ma0<cur_high-coeff*(cur_high-cur_low)) {
         trend =  -1.0; 
         cur_low = ma0; 
         if(!ObjectCreate("Arr " + DoubleToStr(Open[0],Digits),OBJ_ARROW,0,Time[0],Open[0])) {
           Comment("ERROR");
           return(0);
         }
         ObjectSet("Arr " + DoubleToStr(Open[0],Digits),OBJPROP_COLOR,Tomato);
         ObjectSet("Arr " + DoubleToStr(Open[0],Digits),OBJPROP_ARROWCODE,234);
      }   
   }
   if (trend<0) {
      cur_low = MathMin(cur_low,ma0);
      if (ma0>cur_low+coeff*(cur_high-cur_low)) {
         trend =  1.0;  
         cur_high = ma0;
         if(!ObjectCreate("Arr " + DoubleToStr(Open[0],Digits),OBJ_ARROW,0,Time[0],Open[0])) {
           Comment("ERROR");
           return(0);
         }
         ObjectSet("Arr " + DoubleToStr(Open[0],Digits),OBJPROP_COLOR,DeepSkyBlue);
         ObjectSet("Arr " + DoubleToStr(Open[0],Digits),OBJPROP_ARROWCODE,233);
      }   
   }
     
   double in_level = Open[0];  
   if (trend>0) {
     dir1 = 1;
     //in_level = cur_high-in_coeff*(cur_high-cur_low);
   }
   
   if (trend<0) {
     dir1 = -1;
     //in_level = cur_low+in_coeff*(cur_high-cur_low);
   }

   if (dir1>0 && Nb+Ns<=maxLotsN && Open[0]<=in_level) {
     dir1--;
     //dir1 = 0;
      if(dir>0) {
        OpenBuyOrder();
        CloseSellOrder();
      } else {
        OpenSellOrder();
        CloseBuyOrder();
      }
   }
   
   if (dir1<0&& Nb+Ns<=maxLotsN && Open[0]>=in_level) {
     dir1++;
     //dir1 = 0;
      if(dir<0) {
        OpenBuyOrder();
        CloseSellOrder();
      } else {
        OpenSellOrder();
        CloseBuyOrder();
      }
   }

//----
   return(0);
}
//+------------------------------------------------------------------+

int openPositionsDet(int ORDER, string COMMENT)
{  int op =0;
     for(int i=OrdersTotal()-1;i>=0;i--)                                // scan all orders and positions...
      {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() )
         {  
          if ( (OrderType() == ORDER)&&(OrderComment() == COMMENT) ) op++; 
         }
      } 
   return(op);
}
int CloseBuyOrder()
{
     for(int i=OrdersTotal()-1;i>=0;i--) {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() ) {  
          if (OrderType() == OP_BUY) { 
            OrderClose(OrderTicket(),OrderLots(),Bid,0,Green);
          }
        }
    } 
    return(0);
}

int CloseSellOrder()
{
     for(int i=OrdersTotal()-1;i>=0;i--) {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        if (OrderMagicNumber() != MagicNumber) continue;
        if ( OrderSymbol()==Symbol() ) {  
          if (OrderType() == OP_SELL) { 
            OrderClose(OrderTicket(),OrderLots(),Ask,0,Red);
          }
        }
    } 
    return(0);
}

double getF()
{
   double B,dB;
   double Bal0[100];
   int j;
   
   B = AccountBalance();
   
   //    
   if (!CompareDoubles(B,LastB)){
      dB = LastdB + (B-LastB)/(curF1*curF*Lots); 
      LastB = B;
      LastdB = dB;
      strB = strB +  DoubleToStr(dB,2) + " ";
      for (j=0;j<100;j++) {
         Bal0[j]=Bal[j];
      }
      for (j=0;j<99;j++) {
         Bal[j+1]=Bal0[j];
      }
      Bal[0]=dB;   
   }   
   
   double m1, m2;
   string strB1="";
   string strB2="";
   
   m1 = 0.0;
   m2 = 0.0;
   
   for (j=0;j<Nfast;j++) {
      m1 += 1.0/Nfast*Bal[j];
   }

   for (j=0;j<Nslow;j++) {
      m2 += 1.0/Nslow*Bal[j];
   }

   if (m1>m2) {
      Comment(strB2 + "\n" + strB1 + "\n" + "Current F = " + DoubleToStr(F,2) + " m1 = " + DoubleToStr(m1,2) + " m2 = " + DoubleToStr(m2,2));
      return(F);
   } else {
      Comment(strB2 + "\n" + strB1 + "\n" + "Current F = " + DoubleToStr(1.0,2) + " m1 = " + DoubleToStr(m1,2) + " m2 = " + DoubleToStr(m2,2));
      return(1.0);
   }
}

double getF1()
{
   double B,dB;
   double Bal0[100];
   int j;
   
   B = AccountBalance();
   
   //    
   if (!CompareDoubles(B,LastB1)){
      dB = LastdB1 + (B-LastB1)/(Lots*curF1); 
      LastB1 = B;
      LastdB1 = dB;
      for (j=0;j<100;j++) {
         Bal0[j]=Bal1[j];
      }
      for (j=0;j<99;j++) {
         Bal1[j+1]=Bal0[j];
      }
      Bal1[0]=dB;   
   }   
   
   double m1, m2;
   string strB1="";
   string strB2="";
   
   m1 = 0.0;
   m2 = 0.0;
   
   for (j=0;j<Nfast1;j++) {
      m1 += 1.0/Nfast1*Bal1[j];
   }

   for (j=0;j<Nslow1;j++) {
      m2 += 1.0/Nslow1*Bal1[j];
   }

   if (m1>m2) {
      return(F1);
   } else {
      return(1.0);
   }
}


